"use strict";
this.author			= "Neelix"; 
this.copyright		= "© 2014 Neelix."; 
this.licence		= "CC-BY-NC-SA 4.0";
this.name			= "tlxn_waypointHere_eq";
this.description	= "Waypoint Here Equipment Script";

// setup internal waypoint identifiers
this.$wph_waypoints = [
	{key: "wph_alpha", wname: "Waypoint Alpha", code: "A", wpset: false},
	{key: "wph_bravo", wname: "Waypoint Bravo", code: "B", wpset: false},
	{key: "wph_charlie", wname: "Waypoint Charlie", code: "C", wpset: false},
	{key: "wph_delta", wname: "Waypoint Delta", code: "D", wpset: false},
	{key: "wph_echo", wname: "Waypoint Echo", code: "E", wpset: false},
	{key: "wph_foxtrot", wname: "Waypoint Foxtrot", code: "F", wpset: false},
	{key: "wph_golf", wname: "Waypoint Golf", code: "G", wpset: false},
	{key: "wph_hotel", wname: "Waypoint Hotel", code: "H", wpset: false},
];


// Add waypoint at current location
this.activated = function() {
	var wph = worldScripts["tlxn_waypointHere_eq"];
	// look for an unused waypoint identifier
	for (var i = 0; i < wph.$wph_waypoints.length; i++) {
		if (!wph.$wph_waypoints[i].wpset) {
			//unused identifier found - use it and exit function
			system.setWaypoint(
				wph.$wph_waypoints[i].key, player.ship.position, player.ship.orientation,
				{size: 100, beaconCode: wph.$wph_waypoints[i].code, beaconLabel: wph.$wph_waypoints[i].wname}
			);
			wph.$wph_waypoints[i].wpset = true;
			player.consoleMessage(wph.$wph_waypoints[i].wname + " set.", 5);
			worldScripts.Waypoint_Here_MFD.$updateWaypointMFD();
			return;
		}
	}
	//if we get this far then all waypoint identifiers are in use.
	player.consoleMessage("Waypoint Here Memory Full. Please clear a waypoint before attempting to set another",5);
}

// Clear waypoint currently selected on ASC
this.mode = function() {
	var $ct = player.ship.compassTarget;
	var $sw = system.waypoints;
	var wph = worldScripts["tlxn_waypointHere_eq"];
	
	// check position of each waypoint against the postion of the compass target
	for (var i = 0; i < wph.$wph_waypoints.length; i ++) {
		if ($ct && $sw && $sw[wph.$wph_waypoints[i].key] && $ct.position.distanceTo($sw[wph.$wph_waypoints[i].key].position) == 0) {
			//match found - clear the waypoint and exit function
			system.setWaypoint(wph.$wph_waypoints[i].key);
			wph.$wph_waypoints[i].wpset = false;
			player.consoleMessage(wph.$wph_waypoints[i].wname + " cleared",5);
			worldScripts.Waypoint_Here_MFD.$updateWaypointMFD();
			return;
		}
	}
	//if we get this far the compass target did not match one of our waypoints
	player.consoleMessage("No waypoint selected");
}

// reset waypoints on entering a new system
this.shipWillExitWitchspace = function() {
	var wph = worldScripts["tlxn_waypointHere_eq"];
	for (var i = 0; i < wph.$wph_waypoints.length; i ++) {
		if (wph.$wph_waypoints[i].wpset === true) {
			wph.$wph_waypoints[i].wpset = false;
		}
	}	
}

this.shipExitedWitchspace = function() {
	if (system.isInterstellarSpace === true && player.ship.equipmentStatus("EQ_WPH_ASC_UPGRADE") === "EQUIPMENT_OK") {
		// auto-deploy a waypoint at 0, 0, 0
		var wph = worldScripts["tlxn_waypointHere_eq"];
		// always use the "Alpha" waypoint - it should always be free whenever we first arrive in a system
		system.setWaypoint(
			wph.$wph_waypoints[0].key, [0, 0, 0], player.ship.orientation,
			{size: 100, beaconCode: wph.$wph_waypoints[0].code, beaconLabel: wph.$wph_waypoints[0].wname}
		);
		wph.$wph_waypoints[0].wpset = true;
		worldScripts.Waypoint_Here_MFD.$updateWaypointMFD();
		player.consoleMessage("Auto-deploying waypoint for witchspace exit point", 5);
	}
}